<template>
  <div>
    <div class="container my-5" v-if="products.length && categories.length">
      <filters></filters>
      <p class="mt-2"><small>Total of {{ filteredProducts.length }} products</small></p>
      <b-row>
        <b-col
          id="myitems"
          cols="12"
          class="col-sm-6 col-md-4 col-lg-3 clickable hovered"
          v-for="prod in this.filteredProductsPage"
          :key="prod.id"
          :per-page="perPage"
          :current-page="currentPage"
          v-on:click="openDetails(prod.id)">
          <div class="imgWrapper d-flex align-items-end">
            <img :src="prod.image" :alt="prod.title" class="imgHome p-4"/>
          </div>
          <p>
            <strong class="text-muted title">{{ prod.title}}</strong>
            <br><strong>$ {{ prod.price }}</strong>
          </p>
          <p>
            <span v-for="n in 5" :key="n">
              <b-icon variant="warning" class="star" :icon="starFill(n, prod.rating.rate)"></b-icon>
            </span>
            <small class="text-muted"> ({{ prod.rating.count }})</small>
          </p>
        </b-col>
      </b-row>
      <b-pagination
      v-model="currentPage"
      :total-rows="filteredProducts.length"
      :per-page="perPage"
      aria-controls="myitems"
      align="center"
      class="mt-3"
      ></b-pagination>
    </div>
    <div v-else class="text-center text-primary my-5">
      <p>Loading...</p>
      <b-spinner variant="primary" type="grow" label="Spinning"></b-spinner>
    </div>
  </div>
</template>

<script>
import { mapFields } from 'vuex-map-fields'
import Filters from '@/components/Filters.vue'

export default {
  name: 'Homepage',
  data: function () {
    return {
      perPage: 12,
      currentPage: 1
    }
  },
  components: {
    Filters
  },
  mounted () {
    this.fetchData()
  },
  computed: {
    ...mapFields([
      'categories',
      'products',
      'filteredProducts'
    ]),
    filteredProductsPage () {
      return this.filteredProducts.slice(
        (this.currentPage - 1) * this.perPage,
        this.currentPage * this.perPage
      )
    }
  },
  methods: {
    fetchData () {
      fetch('https://fakestoreapi.com/products/categories')
        .then(res => res.json())
        .then(data => (this.categories = data))
        .catch(e => console.log(e))
      fetch('https://fakestoreapi.com/products')
        .then(res => res.json())
        .then(data => {
          this.products = data
          this.filteredProducts = data
        })
        .catch(e => console.log(e))
    },
    openDetails (productId) {
      this.$router.push({ name: 'Product', params: { id: productId } })
    },
    starFill (number, rate) {
      if (rate < (number - 0.9)) {
        return 'star'
      } else if (rate >= (number - 0.9) && rate <= (number - 0.5)) {
        return 'star-half'
      } else {
        return 'star-fill'
      }
    }
  }
}
</script>

<style scoped lang="scss">
.imgHome {
  max-width: 100%;
  max-height: 100%;
}
.imgWrapper {
  height: 250px;
}
.hovered {
  &:hover {
    .title {
      color: rgb(28, 132, 146) !important;
    }
    .star {
      color: rgb(255, 208, 0) !important;
    }
  }
}
</style>
